> This page is for Cash App Pay Partner API.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.cash.app/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.cash.app/_mcp/server.

# List webhook events

GET https://api.cash.app/management/v1/webhook-events

Returns a list of all webhook events matching the query parameters provided. Expired events are not included.

Scopes: `WEBHOOK_EVENTS_READ`

Reference: https://developers.cash.app/cash-app-pay-partner-api/api-reference/management-api/list-webhook-events

## Servers

- `https://api.cash.app/management/v1` (Production, default)
- `https://sandbox.api.cash.app/management/v1` (Sandbox)

## Request

### Query parameters

- `webhook_endpoint_id` (string, optional) — Events delivered to this webhook endpoint ID.
- `status` (enum, optional) — The status of an event that was delivered to a webhook endpoint. The status can either be PENDING, SUCCESS, or FAILED.
  - Allowed values: `PENDING`, `SUCCESS`, `FAILED`
- `event_type` (enum, optional) — The type of event that will be sent to the webhook endpoint.
  - Allowed values: `customer.created`, `customer.deleted`, `customer.updated`, `customer_request.state.updated`, `dispute.created`, `dispute.state.updated`, `grant.created`, `grant.status.updated`, `merchant.status.updated`, `payment.status.updated`, `refund.status.updated`
- `cursor` (string, optional) — A pagination cursor returned by a previous call to this endpoint. Provide this cursor to retrieve the next set of results for the original query.
- `limit` (integer, optional, default: 100) — Maximum number of webhook events to return.

## Response

### 200

OK

- `webhook_events` (list of WebhookEvent, required)
- `cursor` (string, optional) — The pagination cursor to be used in a subsequent request. If empty, this is the final response.

## Errors

### 400 Bad Request Error

Bad Request

- `errors` (list of Error, required) — A list of errors that occurred while processing the request. Min number of items: `1`

## Types

### WebhookEvent

The event that is being sent to a particular webhook endpoint. The event is either in the process of being delivered (PENDING), has been successfully delivered (SUCCESS), or has failed all attempts to deliver (FAILED).

- `id` (string, required) — The unique identifier for a webhook event issued by Cash App.
- `webhook_endpoint_id` (string, required) — This event is delivered to this webhook endpoint ID.
- `event_type` (enum, required) — The type of event that will be sent to the webhook endpoint.
  - Allowed values: `customer.created`, `customer.deleted`, `customer.updated`, `customer_request.state.updated`, `dispute.created`, `dispute.state.updated`, `grant.created`, `grant.status.updated`, `merchant.status.updated`, `payment.status.updated`, `refund.status.updated`
- `status` (enum, required) — The status of an event that was delivered to a webhook endpoint. The status can either be PENDING, SUCCESS, or FAILED. PENDING: The webhook event has been dispatched and is in the process of being delivered to the endpoint. If the event has failed and is being retried, it will continue to be in the PENDING status. SUCCESS: The webhook event has been delivered to the endpoint and we've received receipt of the delivery from the client's endpoint (e.g. 200OK). FAILED: The webhook event has failed all delivery attempts for 72 hours. No more deliveries will be attempted.
  - Allowed values: `PENDING`, `FAILED`, `SUCCESS`
- `created_at` (datetime, required) — The timestamp of when the event was created.
- `updated_at` (datetime, required) — The timestamp of when the event was last updated.
- `expires_at` (datetime, required) — The timestamp of when this event will expire and no longer be available in Cash App.
- `event_data` (EventData, required) — This represents the data that is delivered to a webhook endpoint.
- `api_version` (string, required) — The API version used to serialize the event data.

### Error

Represents an error encountered during a request to the API.

- `category` (enum, required) — The high-level reason the error occurred
  - Allowed values: `API_ERROR`, `AUTHENTICATION_ERROR`, `BRAND_ERROR`, `DISPUTE_ERROR`, `MERCHANT_ERROR`, `INVALID_REQUEST_ERROR`, `PAYMENT_PROCESSING_ERROR`, `RATE_LIMIT_ERROR`, `WEBHOOK_ERROR`, `API_KEY_ERROR`, `GRANT_ERROR`
- `code` (string, required) — A unique identifier for the specific type of error that occurred. See the Error Code Reference for more information. Min length: `1`
- `detail` (string, optional) — Human-readable description of why the error occurred and how to resolve it. Min length: `1`
- `field` (string, optional) — The field in the request that caused the error, using array and object dot notation. Min length: `1`

### EventData

This represents the data that is delivered to a webhook endpoint.

- `event_id` (string, required) — The unique ID of the webhook event.
- `type` (enum, required) — The type of event that will be sent to the webhook endpoint.
  - Allowed values: `customer.created`, `customer.deleted`, `customer.updated`, `customer_request.state.updated`, `dispute.created`, `dispute.state.updated`, `grant.created`, `grant.status.updated`, `merchant.status.updated`, `payment.status.updated`, `refund.status.updated`
- `created_at` (datetime, required) — The timestamp of when the event was created.
- `data` (EventDataData, required) — The underlying data encapsulated in the event.

### EventDataData

The underlying data encapsulated in the event.

- `id` (string, required) — The unique ID provided by Cash App for the resource contained in the event.
- `object` (EventDataDataObject, required) — The snapshot of the resource contained in the event.
- `type` (enum, required) — The type of the resource contained in the event.
  - Allowed values: `customer`, `merchant`, `dispute`, `grant`, `payment`, `refund`, `request`

### EventDataDataObject

The snapshot of the resource contained in the event.

### customer

- `customer` (Customer, optional)

### merchant

- `merchant` (Merchant, optional) — A merchant represents a depository account when processing payments from Cash App customers. Merchants do not have direct access to Cash App, so processed payments are stored in this account until they are ready for settlement.

### dispute

- `dispute` (Dispute, optional) — Represents a dispute initiated by a customer within Cash App or the customer's linked bank

### payment

- `payment` (Payment, optional)

### grant

- `grant` (Grant, optional) — Describes a grant that can be used to perform actions specified in a customer request using the Network API.

### refund

- `refund` (Refund, optional)

### EventDataDataObject6

- `request` (Request, optional) — Describes a request from a client to perform a given action on a customer's account.

### Customer

- `id` (string, required) — Unique identifier for this customer issued by Cash App. Min length: `1` Max length: `128`
- `cashtag` (string, required) — Public identifier for the customer on Cash App. [Learn more](https://cash.app/help/us/en-us/3123-cashtags). Min length: `1` Max length: `1024`
- `reference_id` (string, optional) — A user-defined identifier for this customer, typically used to associate the customer with a record in an external system. This value can be provided via the `CustomerRequest.customer_metadata.reference_id` attribute. Upon approval of the CustomerRequest, a corresponding customer resource is created with the `reference_id` attribute.

### Merchant

A merchant represents a depository account when processing payments from Cash App customers. Merchants do not have direct access to Cash App, so processed payments are stored in this account until they are ready for settlement.

- `id` (string, required) — A unique identifier for the merchant issued by Cash App. Min length: `1` Max length: `128`
- `brand_id` (string, required) — ID of the brand associated with this merchant. Min length: `1` Max length: `128`
- `name` (string, required) — The name of the individual or business entity associated with the merchant. Min length: `1` Max length: `1024`
- `country` (enum, required) — Indicates the country associated with an entity. Values are from the [ISO-3166 Alpha-2](https://www.iso.org/iso-3166-country-codes.html) specification. Current values: - `US`: United States of America
  - Allowed values: `US`
- `currency` (enum, required) — Indicates the country associated with an entity. Values are from the [ISO-4217 Alpha-3](https://www.iso.org/iso-4217-currency-codes.html) specification. Current values: - `USD`: United States Dollar
  - Allowed values: `USD`
- `category` (string, required) — The merchant category code associated with the entity. Values are from the [ISO-18245 specification](https://www.iso.org/standard/33365.html).
- `reference_id` (string, required) — A user-defined identifier for this merchant, typically used to associate the merchant with a record in an external system. Independent from the [brand reference_id](https://developers.cash.app/docs/api/network-api/operations/create-a-brand#request-body). Min length: `1` Max length: `1024`
- `status` (enum, required) — Whether or not this merchant can be used to accept payments or issue refunds. * `ACTIVE`: The merchant can accept payments or issue refunds. * `RISK_DISABLED`: Cash App Pay blocked this merchant due to them being high risk. There is no way to re-enable them programmaticaly. * `COMPLIANCE_DISABLED`: Cash App Pay blocked this merchant due to them not following the terms of service, Program Rules, or local laws. There is no way to re-enable them programmaticaly. * `CLIENT_DISABLED`: The client called the [UpdateMerchant](Network-API.v1.yaml/paths/~1merchants~1\{merchant_id}/patch) endpoint and disabled this merchant, preventing it from being able to handle payments or refunds. To reverse this, call the endpoint again with the status field set to `ACTIVE`. * `PENDING`: The merchant is not ready to accept payments or refunds yet; the registration process is still running.
  - Allowed values: `ACTIVE`, `RISK_DISABLED`, `COMPLIANCE_DISABLED`, `CLIENT_DISABLED`, `PENDING`
- `created_at` (datetime, required) — When this merchant was created, in [RFC 3339](https://datatracker.ietf.org/doc/html/rfc3339) format (UTC).
- `updated_at` (datetime, required) — When this merchant was last updated, in [RFC 3339](https://datatracker.ietf.org/doc/html/rfc3339) format (UTC).
- `address` (Address, required) — Where this entity is located
- `site_url` (string, optional) — The URL of the website, if this merchant is for an eCommerce site. Min length: `8` Max length: `8000`
- `metadata` (map from string to string, optional) — Freeform key-value pairs of arbitrary data associated with this resource. Keys and values must be passed as strings and not contain any personally identifiable information (PII). Min keys: `0` Max keys: `50` > Note: Nested keys are not supported.
- `default_fee_plans` (MerchantFeePlans, optional) — Merchant fee plans contains the IDs of the different fee plans for a merchant. These IDs represent the processing fees that merchants will be charged for processing payments for each channel. You can use the Fee Plans API to get all the fee information for each fee plan.

### Dispute

Represents a dispute initiated by a customer within Cash App or the customer's linked bank

- `id` (string, required) — A unique identifier for the dispute issued by Cash App. Min length: `1` Max length: `128`
- `payment_id` (string, required) — ID of the disputed payment. Min length: `1` Max length: `128`
- `amount` (integer, required) — Amount of disputed money, in the lowest denomination of currency on the associated payment. Min value: `1`
- `reason` (enum, required) — 4-digit code consisting of 2 letters followed by 2 numbers that indicates why the dispute was created, at a high level. Current values: - `FR10`: Customer has no knowledge of the payment. - `FR11`: Customer has no knowledge of the payment and liability has shifted to the merchant due to collusion, fraud monitoring program thresholds, or any other reason. - `PE10`: Payment was processed twice. - `PE11`: Payment amount differs from agreed amount. - `PE12`: Payment was paid for by another means. - `CD10`: Cancelled services. - `CD11`: Goods or services differ from what was agreed upon for the payment. - `CD12`: The goods or services were not received. - `CD13`: The purchase was cancelled or returned, but the refund has not been processed.
  - Allowed values: `FR10`, `FR11`, `PE10`, `PE11`, `PE12`, `CD10`, `CD11`, `CD13`
- `settlement_withholding` (enum, required) — Indicates if the disputed amount has already been withheld from a settlement or not. Current values: - `NOT_WITHHELD`: The disputed amount has not yet been withheld in a settlement. It may impact future settlements if the dispute is "lost" by the merchant. - `WITHHELD_ALREADY`: The disputed amount was withheld in a prior settlement. This dispute will not impact future settlements.
  - Allowed values: `NOT_WITHHELD`, `WITHHELD_ALREADY`
- `state` (enum, required) — The step in the dispute lifecycle that this dispute is currently at: - `RESPONSE_REQUIRED` - `NO_RESPONSE_REQUIRED` - `PROCESSING` - `ACCEPTED` - `WON` - `PARTIALLY_WON` - `LOST`
  - Allowed values: `RESPONSE_REQUIRED`, `NO_RESPONSE_REQUIRED`, `PROCESSING`, `ACCEPTED`, `WON`, `PARTIALLY_WON`, `LOST`
- `created_at` (datetime, required) — When this dispute was created, in [RFC 3339](https://datatracker.ietf.org/doc/html/rfc3339) format (UTC).
- `updated_at` (datetime, required) — When this dispute was last updated, in [RFC 3339](https://datatracker.ietf.org/doc/html/rfc3339) format (UTC).
- `merchant_id` (string, required) — ID of the merchant that collected the disputed payment. Min length: `1` Max length: `128`
- `customer_credited_amount` (integer, optional, nullable) — The amount credited to the Customer after resolving the dispute. Note: The amount will be in the lowest denomination of the currency used on the associated payment. Min value: `0`
- `response_due_at` (datetime, optional, nullable) — When the dispute must be challenged by, after which it will be automatically accepted, in [RFC 3339](https://datatracker.ietf.org/doc/html/rfc3339) format (UTC).

### Payment

- `id` (string, required) — Unique identifier for this payment issued by Cash App. Min length: `1` Max length: `128`
- `amount` (integer, required) — The amount of money to collect, in the lowest denomination of currency on the payment. This is the _original_ amount authorized when the payment was created. Min value: `1`
- `net_amount` (integer, required) — The amount remaining after refunds and voided payments are deducted from the amount field. The amount will be in the lowest denomination of the currency on the payment. This is the amount that will be shown to the customer in their Cash App account. Min value: `0`
- `captured_amount` (integer, required) — The amount of money on this payment that has been allocated for settlement. The amount will be in the lowest denomination of the currency on the payment. Min value: `0`
- `voided_amount` (integer, required) — The amount of money on this payment that is no longer authorized and has been released back to the customer. The amount will be in the lowest denomination of the currency on the payment. Min value: `0`
- `refunded_amount` (integer, required) — Sum of captured refunds in the lowest denomination of currency on the payment. Min value: `0`
- `currency` (enum, required) — Indicates the country associated with an entity. Values are from the [ISO-4217 Alpha-3](https://www.iso.org/iso-4217-currency-codes.html) specification. Current values: - `USD`: United States Dollar
  - Allowed values: `USD`
- `customer_id` (string, required) — ID of the customer that sent this payment. Min length: `1` Max length: `128`
- `merchant_id` (string, required) — ID of the merchant that received this payment. Min length: `1` Max length: `128`
- `grant_id` (string, required) — ID of the grant to used to create this payment. Min length: `1` Max length: `256`
- `status` (enum, required) — The step of the payment processing lifecycle that this payment is currently at. - `AUTHORIZED` - `CAPTURED` - `VOIDED` - `DECLINED`
  - Allowed values: `AUTHORIZED`, `CAPTURED`, `VOIDED`, `DECLINED`
- `created_at` (datetime, required) — When this payment was created, in [RFC 3339](https://datatracker.ietf.org/doc/html/rfc3339) format (UTC).
- `updated_at` (datetime, required) — When this payment was last updated, in [RFC 3339](https://datatracker.ietf.org/doc/html/rfc3339) format (UTC).
- `capture_before` (datetime, optional) — When this payment should be captured by, in [RFC 3339](https://datatracker.ietf.org/doc/html/rfc3339) format (UTC).
- `refund_ids` (list of string, optional) — A list of one or more IDs associated with refunds issued for this payment. Min array length: `1` Min length of IDs: `1` Max length of IDs: `128`
- `reference_id` (string, optional) — A user-defined identifier for this payment, typically used to associate the payment with a record in an external system. Min length: `1` Max length: `1024`
- `metadata` (map from string to string, optional) — Freeform key-value pairs of arbitrary data associated with this resource. Keys and values must be passed as strings and not contain any personally identifiable information (PII). Min keys: `0` Max keys: `50` > Note: Nested keys are not supported.
- `enrichments` (PaymentEnrichments, optional) — Describes optional fields beyond core payment information to supplement payment processing. Enrichments provide additional context about a payment, which can improve the overall payment experience including, but not limited to: - Increased approval rates - Enhanced transaction insights - Better payment flows in Cash App
- `decline_errors` (list of Error, optional) — If the payment was declined, contains a list of the reasons why it was declined. Min number of items: `1`
- `fee_amount` (double, optional) — The total fee amount that was charged to the merchant for processing this payment.
- `fee_rate` (FeeRate, optional) — The breakdown of the fee that was charged to the merchant for processing this payment.
- `authorization_updates` (list of Authorization, optional) — A list of authorization update attempts associated with this payment, sorted in chronological order. Note: This field contains only the authorization update attempts, so this field will be empty when the payment is first created (even though the amount is authorized in this flow, it is not an update).

### Grant

Describes a grant that can be used to perform actions specified in a customer request using the Network API.

- `id` (string, required) — Unique identifier for this grant issued by Cash App. Min length: `1` Max length: `256`
- `customer_id` (string, required) — ID of the customer that approved this grant. Min length: `1` Max length: `128`
- `request_id` (string, required) — A unique identifier issued by Cash App for the customer request that resulted in the creation of this grant. Min length: `1` Max length: `128`
- `action` (Action, required) — Represents what the client intends to do to a customer if given authorization.
- `status` (enum, required) — Describes whether or not this grant can be used to perform the action associated with it. If `ACTIVE`, it can be used to perform the action. If `EXPIRED`, it may no longer be used to perform the action due to the current time being past the "expires_at" time. If `CONSUMED`, it was already redeemed to perform the action and cannot be used again. If `REVOKED`, the customer or merchant explicitly unauthorized the grant, preventing it from being used to perform the action.
  - Allowed values: `ACTIVE`, `CONSUMED`, `REVOKED`, `EXPIRED`
- `type` (enum, required) — Describes whether this grant can be only be used once (`ONE_TIME`) or repeatedly (`EXTENDED`).
  - Allowed values: `ONE_TIME`, `EXTENDED`
- `channel` (enum, required) — How the customer is expected to interact with the request. - `IN_PERSON`: The customer presents or scans a QR code at a physical location to approve the request. - `ONLINE`: The customer scans a QR code or is redirected to Cash App from a browser context. - `IN_APP`: The customer scans a QR code or is redirected to Cash App from a native mobile application context.
  - Allowed values: `IN_PERSON`, `ONLINE`, `IN_APP`
- `created_at` (datetime, required) — When this grant was created, in [RFC 3339](https://datatracker.ietf.org/doc/html/rfc3339) format (UTC).
- `updated_at` (datetime, required) — When this grant was last updated, in [RFC 3339](https://datatracker.ietf.org/doc/html/rfc3339) format (UTC).
- `expires_at` (datetime, optional) — If present, indicates when the grant's status will become `EXPIRED`, preventing a client from using it to create payments or refunds. The timestamp is in the [RFC 3339](https://datatracker.ietf.org/doc/html/rfc3339) format (UTC).

### Refund

- `id` (string, required) — Unique identifier for this refund issued by Cash App. Min length: `1` Max length: `128`
- `amount` (integer, required) — Amount of money to refund, in the lowest denomination of currency on the refund. Min value: `1`
- `currency` (enum, required) — Indicates the country associated with an entity. Values are from the [ISO-4217 Alpha-3](https://www.iso.org/iso-4217-currency-codes.html) specification. Current values: - `USD`: United States Dollar
  - Allowed values: `USD`
- `customer_id` (string, required) — ID of the customer that received this refund. Min length: `1` Max length: `128`
- `merchant_id` (string, required) — ID of the merchant that issued this refund. Min length: `1` Max length: `128`
- `status` (enum, required) — The step of the refund processing lifecycle that this refund is currently at. - `AUTHORIZED` - `CAPTURED` - `VOIDED` - `DECLINED`
  - Allowed values: `AUTHORIZED`, `CAPTURED`, `VOIDED`, `DECLINED`
- `created_at` (datetime, required) — When this refund was created, in [RFC 3339](https://datatracker.ietf.org/doc/html/rfc3339) format (UTC).
- `updated_at` (datetime, required) — When this refund was last updated, in [RFC 3339](https://datatracker.ietf.org/doc/html/rfc3339) format (UTC).
- `grant_id` (string, optional) — This is currently unused and empty. Min length: `1` Max length: `256`
- `payment_id` (string, optional) — This is currently unused and empty. Min length: `1` Max length: `128`
- `reference_id` (string, optional) — A user-defined identifier for this refund, typically used to associate the refund with a record in an external system. Min length: `1` Max length: `1024`
- `metadata` (map from string to string, optional) — Freeform key-value pairs of arbitrary data associated with this resource. Keys and values must be passed as strings and not contain any personally identifiable information (PII). Min keys: `0` Max keys: `50` > Note: Nested keys are not supported.
- `decline_errors` (list of Error, optional) — If the refund was declined, contains a list of the reasons why it was declined. Min number of items: `1`

### Request

Describes a request from a client to perform a given action on a customer's account.

- `id` (string, required) — A unique identifier for the request issued by Cash App. Min length: `1` Max length: `128`
- `status` (enum, required, default: PENDING) — Indicates if the state is approved, declined, or pending. Approved requests have grants, while pending and declined grants do not. Current values: - `PENDING`: The request has been created, but not responded to. - `PROCESSING`: The Cash App customer is actively responding to the request on their mobile device, and will require time to fill out information before the request is approved / declined. - `APPROVED`: The request was approved by the customer and grants have been created for the provided actions. - `DECLINED`: The request was denied by the customer. No grants were created.
  - Allowed values: `APPROVED`, `DECLINED`, `PENDING`, `PROCESSING`
- `actions` (list of Action, required) — Represents what the client intends to do to a customer if given authorization. No duplicate action types allowed. Min number of items: `1` Max number of items: `5`
- `redirect_url` (string, required) — If this request is responded to via mobile redirect, this field specifies the URL that Cash App will open for a customer in the mobile device's default browser after the request is approved or declined.
- `created_at` (datetime, required) — When this customer request was created, in [RFC 3339](https://datatracker.ietf.org/doc/html/rfc3339) format (UTC).
- `updated_at` (datetime, required) — When the customer request was last updated, in [RFC 3339](https://datatracker.ietf.org/doc/html/rfc3339) format (UTC).
- `expires_at` (datetime, required) — When this customer request will be automatically declined by Cash App, in [RFC 3339](https://datatracker.ietf.org/doc/html/rfc3339) format (UTC).
- `origin` (RequestOrigin, required) — Metadata describing how the customer request was created.
- `channel` (enum, required) — How the customer is expected to interact with the request. - `IN_PERSON`: The customer presents or scans a QR code at a physical location to approve the request. - `ONLINE`: The customer scans a QR code or is redirected to Cash App from a browser context. - `IN_APP`: The customer scans a QR code or is redirected to Cash App from a native mobile application context.
  - Allowed values: `IN_PERSON`, `ONLINE`, `IN_APP`
- `auth_flow_triggers` (RequestAuthFlowTriggers, optional) — While the request is `PENDING`, contains different methods that can be used to start the authorization flow in the Cash App mobile application. Its contents refresh each time the `refreshes_at` timestamp passes. When the data refreshes, you should update any buttons or QR codes referring to it immediately. After a request has been scanned (and is no longer in the `PENDING` status), this field will no longer be returned.
- `grants` (list of Grant, optional) — If present, contains grants that can be used to perform actions specified in the request using the Network API. Each grant corresponds directly to an action on the request. Min number of items: `1` Max number of items: `5`
- `reference_id` (string, optional) — A user-defined identifier for this request, typically used to associate the resource with a record in an external system. Min length: `1` Max length: `1024`
- `requester_profile` (RequestRequesterProfile, optional) — Details about the brand or client that are requesting permission to perform the actions on the customer request.
- `customer_profile` (RequestCustomerProfile, optional) — If the customer request was approved, contains the identity of the Cash App customer that approved it.
- `metadata` (map from string to string, optional) — Freeform key-value pairs of arbitrary data associated with this resource. Keys and values must be passed as strings and not contain any personally identifiable information (PII). Min keys: `0` Max keys: `50` > Note: Nested keys are not supported.
- `customer_metadata` (CustomerMetadata, optional) — Metadata to associate with the customer that approves this request.

### Address

Where this entity is located

- `country` (enum, required) — Indicates the country associated with an entity. Values are from the [ISO-3166 Alpha-2](https://www.iso.org/iso-3166-country-codes.html) specification. Current values: - `US`: United States of America
  - Allowed values: `US`
- `address_line_1` (string, optional) — First line of the street address, typically including street number, street name, and / or building name. Min length: `1` Max length: `1024`
- `address_line_2` (string, optional) — Second line of the address, if any. Min length: `1` Max length: `1024`
- `locality` (string, optional) — City or township where the entity is located. Min length: `1` Max length: `1024`
- `postal_code` (string, optional) — ZIP or postal code. Min length: `1` Max length: `128`
- `administrative_district_level_1` (string, optional) — State or province. Min length: `1` Max length: `1024`

### MerchantFeePlans

Merchant fee plans contains the IDs of the different fee plans for a merchant. These IDs represent the processing fees that merchants will be charged for processing payments for each channel. You can use the Fee Plans API to get all the fee information for each fee plan.

- `in_app_fee_plan_id` (string, optional) — The fee plan ID identifying the fee plan that will be used for all in-app payments.
- `in_person_fee_plan_id` (string, optional) — The fee plan ID identifying the fee plan that will be used for all in-person payments.
- `online_fee_plan_id` (string, optional) — The fee plan ID identifying the fee plan that will be used for all online payments.

### PaymentEnrichments

Describes optional fields beyond core payment information to supplement payment processing. Enrichments provide additional context about a payment, which can improve the overall payment experience including, but not limited to: - Increased approval rates - Enhanced transaction insights - Better payment flows in Cash App

- `initiation` (PaymentEnrichmentsInitiation, optional) — If present, provides information about transaction initiation.
- `recurring_series_id` (string, optional) — If present, indicates that this payment is part of a recurring series of payments, such as a subscription. The value should contain a unique identifier for the recurring series that is constant across all of its payments, so it can be used to group them together. Min length: `1` Max length: `1024`
- `statement_descriptor` (string, optional) — If present, adds the descriptor as line item on to a customer's payment receipt in their in-app Activity page. The descriptor will be present under the header "On statement as". Statement descriptor requirements vary by platform. If the input for this field exceeds the character limit, it will be truncated to the limit, then suffixed with an ellipsis (...). Min length: `1` Max length: `22`
- `restricted_categories` (list of enum, optional) — If present, indicates that this payment is associated with one or more restricted categories. Contact the Cash App Pay support team to use this field.
  - Allowed values: `ALCOHOL`, `FINANCIAL_SERVICES`

### FeeRate

A fee rate contains the components of a fee charged by Cash App to partners for a given payment.

- `basis_points` (integer, optional) — The variable fee charged for processing the payment expressed as 1/100th of a percentage.
- `fixed_amount` (integer, optional) — The amount charged for processing the payment, in the lowest denomination of currency on the payment. **Note: The currency for the fee is found on the fee plan.**

### Authorization

Represents an authorization update for a payment

- `id` (string, required) — Unique identifier for this authorization issued by Cash App. Min length: 1 character Max length: 128 characters
- `amount` (integer, required) — Total authorized amount after this authorization was processed, in the lowest denomination of currency on the payment.
- `currency` (enum, required) — Indicates the country associated with an entity. Values are from the [ISO-4217 Alpha-3](https://www.iso.org/iso-4217-currency-codes.html) specification. Current values: - `USD`: United States Dollar
  - Allowed values: `USD`
- `status` (enum, required) — The step of the authorization processing lifecycle that this authorization is currently at. Allowed values: - AUTHORIZED - DECLINED
  - Allowed values: `AUTHORIZED`, `DECLINED`
- `created_at` (datetime, required) — When this authorization was created, in RFC 3339 format (UTC).
- `payment_id` (string, required) — ID of the payment associated with this authorization
- `previous_amount` (integer, required) — Total authorized amount before this authorization was requested
- `reference_id` (string, optional) — A user-defined identifier for this authorization, typically used to associate the authorization with a record in an external system. Min length: 1 Max length: 1024
- `metadata` (map from string to string, optional) — Freeform key-value pairs of arbitrary data associated with this resource. Keys and values must be passed as strings and not contain any personally identifiable information (PII). Min keys: `0` Max keys: `50` > Note: Nested keys are not supported.
- `decline_errors` (list of Error, optional) — If the authorization was declined, it contains a list of the reasons why it was declined. Min number of items: 1

### Action

Represents what the client intends to do to a customer if given authorization.

- `type`: `ONE_TIME_PAYMENT` (One Time Payment Action)
  - `scope_id` (string, required) — ID of the client, brand, or merchant that will charge the customer. If a client ID is passed, the grant from this action can be used to create a payment for any merchant owned by the client. If a brand ID is passed, the grant from this action can be used to create a payment for any merchant that has a matching brand ID. If a merchant ID is passed, the grant from this action can be used to create a payment for the merchant with a matching ID. Min length: `1` Max length: `128`
  - `amount` (integer, optional) — Amount to charge the customer, in the lowest unit of the associated currency. Min value: `1`
  - `currency` (enum, optional) — Indicates the country associated with an entity. Values are from the [ISO-4217 Alpha-3](https://www.iso.org/iso-4217-currency-codes.html) specification. Current values: - `USD`: United States Dollar
    - Allowed values: `USD`
- `type`: `ON_FILE_PAYMENT` (On File Payment Action)
  - `scope_id` (string, required) — ID of the client or brand that will charge customers. If a client ID is passed, the grant from this action can be used to create a payment for any merchant owned by the client. If a brand ID is passed, the grant from this action can be used to create a payment for any merchant that has a matching brand ID. Merchant IDs may *not* be passed. Min length: `1` Max length: `128`
  - `account_reference_id` (string, optional) — Identifier of the account or customer associated to the on file action.
- `type`: `ON_FILE_DEPOSIT` (On File Deposit Action)
  - `account_reference_id` (string, required) — Identifier of the account or customer associated to the on file action.
  - `scope_id` (string, required) — ID of the client or brand that indicates the set of merchants that will deposit to customers. If a client ID is passed, the grant from this action can be used to create a deposit for any merchant owned by the client. If a brand ID is passed, the grant from this action can be used to create a deposit for any merchant that has a matching brand ID. Min length: `1` Max length: `128`
- `type`: `LINK_ACCOUNT` (Link Account Action)

### RequestOrigin

Metadata describing how the customer request was created.

- `type` (enum, required) — The method used to create the customer request. - `DIRECT` - the client or SDKs created this customer request by calling the "CreateCustomerRequest" endpoint - `REQUEST_INITIATOR` - a customer interacted with a request initiator and caused Cash App to create a customer request.
  - Allowed values: `DIRECT`, `REQUEST_INITIATOR`
- `id` (string, optional) — If present, is the ID of the initiator used to create this request. Min length: `1` Max length: `128`

### RequestAuthFlowTriggers

While the request is `PENDING`, contains different methods that can be used to start the authorization flow in the Cash App mobile application. Its contents refresh each time the `refreshes_at` timestamp passes. When the data refreshes, you should update any buttons or QR codes referring to it immediately. After a request has been scanned (and is no longer in the `PENDING` status), this field will no longer be returned.

- `qr_code_image_url` (string, required) — Link to a QR code customers can scan with Cash App to authorize the given action, encoded as a PNG file. Min length: `8` Max length: `1024`
- `qr_code_svg_url` (string, required) — Link to a QR code customers can scan with Cash App to authorize the given action, encoded as an SVG file. Min length: `8` Max length: `1024`
- `mobile_url` (string, required) — If on an Android or iOS device, the URL to redirect customers to in order to authorize the given action. Min length: `8` Max length: `1024`
- `refreshes_at` (datetime, required) — When the QR code image URL will be rotated. Generally, it will rotate every ~20 seconds and become invalid after 30 seconds.
- `desktop_url` (string, optional) — If on a desktop browser, the URL to redirect customers to in order to authorize the given action. Min length: `8` Max length: `1024`

### RequestRequesterProfile

Details about the brand or client that are requesting permission to perform the actions on the customer request.

- `name` (string, required) — Name of the brand to be shown in Cash App next to payments. Min length: `1` Max length: `1024`
- `logo_url` (string, required) — URL to the image of the entity (brand or client) that is requesting permission to perform the actions on the customer request. Formats: - `.jpg` - `.jpeg` - `.png` Min length: `8` Max length: `8000`

### RequestCustomerProfile

If the customer request was approved, contains the identity of the Cash App customer that approved it.

- `id` (string, required) — Unique identifier for this customer issued by Cash App. Min length: `1` Max length: `128`
- `cashtag` (string, required) — Public identifier for the customer on Cash App. [Learn more](https://cash.app/help/us/en-us/3123-cashtags). Min length: `1` Max length: `1024`

### CustomerMetadata

Metadata to associate with the customer that approves this request.

- `reference_id` (string, optional) — The `reference_id` of the customer approving this request. When a customer approves this request, that customer will be associated with this `reference_id`.

### PaymentEnrichmentsInitiation

If present, provides information about transaction initiation.

- `actor` (enum, required) — The party who initiated the payment. - `CUSTOMER` - `MERCHANT`
  - Allowed values: `CUSTOMER`, `MERCHANT`

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "webhook_events": [
    {
      "id": "WE_2f6cd0d5cc26b34ac8785026b149797ecc0758be3dc3a857d405f2f62074ef30",
      "webhook_endpoint_id": "WC_2f6cd0d5cc26b34ac8785026b149797ecc0758be3dc3a857d405f2f62074ef30",
      "event_type": "customer.created",
      "status": "PENDING",
      "created_at": "2024-01-15T09:30:00Z",
      "updated_at": "2024-01-15T09:30:05Z",
      "expires_at": "2024-04-15T09:30:00Z",
      "event_data": {
        "event_id": "WE_2f6cd0d5cc26b34ac8785026b149797ecc0758be3dc3a857d405f2f62074ef30",
        "type": "customer.created",
        "created_at": "2024-01-15T09:30:00Z",
        "data": {
          "id": "CST_AQmxh4y_QGoNNIG5NUw0jttqyYedL1LklACQdyJ3H-Vs6WmLtP6A_C7XjQNohvY",
          "object": {
            "customer": {
              "cashtag": "$johndoe",
              "id": "CST_AQmxh4y_QGoNNIG5NUw0jttqyYedL1LklACQdyJ3H-Vs6WmLtP6A_C7XjQNohvY",
              "reference_id": "CUST_123"
            }
          },
          "type": "customer"
        }
      },
      "api_version": "2024-01-15"
    }
  ],
  "cursor": "WE_9a3bc1e7dd48f25bc9012347e258908faa1869cd4ef4b968e516g3g73185fg41"
}
```

**SDK Code**

```python
import requests

url = "https://api.cash.app/management/v1/webhook-events"

payload = {}
headers = {
    "Accept": "Accept",
    "User-Agent": "User-Agent",
    "X-Region": "X-Region",
    "X-Signature": "X-Signature",
    "Content-Type": "application/json"
}

response = requests.get(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.cash.app/management/v1/webhook-events';
const options = {
  method: 'GET',
  headers: {
    Accept: 'Accept',
    'User-Agent': 'User-Agent',
    'X-Region': 'X-Region',
    'X-Signature': 'X-Signature',
    'Content-Type': 'application/json'
  },
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.cash.app/management/v1/webhook-events"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("GET", url, payload)

	req.Header.Add("Accept", "Accept")
	req.Header.Add("User-Agent", "User-Agent")
	req.Header.Add("X-Region", "X-Region")
	req.Header.Add("X-Signature", "X-Signature")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.cash.app/management/v1/webhook-events")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Accept"] = 'Accept'
request["User-Agent"] = 'User-Agent'
request["X-Region"] = 'X-Region'
request["X-Signature"] = 'X-Signature'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.cash.app/management/v1/webhook-events")
  .header("Accept", "Accept")
  .header("User-Agent", "User-Agent")
  .header("X-Region", "X-Region")
  .header("X-Signature", "X-Signature")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.cash.app/management/v1/webhook-events', [
  'body' => '{}',
  'headers' => [
    'Accept' => 'Accept',
    'Content-Type' => 'application/json',
    'User-Agent' => 'User-Agent',
    'X-Region' => 'X-Region',
    'X-Signature' => 'X-Signature',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.cash.app/management/v1/webhook-events");
var request = new RestRequest(Method.GET);
request.AddHeader("Accept", "Accept");
request.AddHeader("User-Agent", "User-Agent");
request.AddHeader("X-Region", "X-Region");
request.AddHeader("X-Signature", "X-Signature");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Accept": "Accept",
  "User-Agent": "User-Agent",
  "X-Region": "X-Region",
  "X-Signature": "X-Signature",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.cash.app/management/v1/webhook-events")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```